*******************************************************************************
*                          680xx Grundprogramm clut                           *
*                             2009 Jens Mewes                                 *
*                               V 7.10 Rev 4                                  *
*                                01.05.2009                                   *
*                              Clut-Routinen                                  *
*******************************************************************************


clutinit:                       * CLUT initialisieren
 movem.l a0, -(a7)
 btst.b #6, keydil(a5)          * GDP-FPGA da?
 beq.s clutinex                 * Nein!
 tst.b gdpcol(a5)               * Farbvariante
 beq.s clutinex                 * Nein, dann Ende
 lea cluttab(pc), a0            * Standard Farben
 bsr clut                       * Laden
clutinex:
 movem.l (a7)+, a0
rts

clut:                           * Farben der CLUT beliebig einstellen
 movem.l d0, -(a7)
 btst.b #6, keydil(a5)          * GDP-FPGA da?
 beq.s clutex                   * Nein
 tst.b gdpcol(a5)               * Farbvariante?
 beq.s clutex                   * Nein, dann Ende
 clr.b cluta.w                  * FPGA-CLUT Adresse 0
 moveq #16-1, d0
 ori #$0700, sr                 * Interrupts aus
clut01:
 move.b (a0)+, cluth.w          * FPGA-CLUT Daten high
 move.b (a0)+, clutl.w          * FPGA-CLUT Daten low
 dbra d0, clut01
clutex:
 andi #$f8ff, sr                * Interrupts an
 movem.l (a7)+, d0
rts

cluttab:
dc.w $000                       * 0  Schwarz        RGB 0,0,0
dc.w $1ff                       * 1  Wei           RGB 255,255,255
dc.w $1f8                       * 2  Gelb           RGB 255,255,0
dc.w $038                       * 3  Grn           RGB 0,255,0
dc.w $1c0                       * 4  Rot            RGB 255,0,0
dc.w $007                       * 5  Blau           RGB 0,0,255
dc.w $1c7                       * 6  Violett        RGB 255,0,255
dc.w $03f                       * 7  Zyan           RGB 0,255,255
dc.w $092                       * 8  Dunkelgrau     RGB 64,64,64
dc.w $124                       * 9  Hellgrau       RGB 128,128,128
dc.w $0d8                       * 10 Dunkelgelb     RGB 96,96,0
dc.w $018                       * 11 Dunkelgrn     RGB 0,96,0
dc.w $0c0                       * 12 Dunkelrot      RGB 96,0,0
dc.w $003                       * 13 Dunkelblau     RGB 0,0,96
dc.w $0c3                       * 14 Violett dunkel RGB 96,0,96
dc.w $01b                       * 15 Zyan dunkel    RGB 0,96,96
